// Track how much time user actively spends reading the story (more time = better story)
"use strict";
// globals: document, window, DH

var ST = ST || {};

ST.active = (function () {
    // Track active time
    var self = {}, oldTime = 0, stopped = false;
    self.time = 0;

    function onEvent() {
        // measure time
        var t = Date.now();
        if (t - oldTime < 60000) {
            if (!stopped) {
                self.time += (t - oldTime) / 1000;
            }
        }
        oldTime = t;
    }

    self.report = function (aCallback) {
        // send how long user actively spent reading story back to server
        onEvent();
        var story_id = ST.story.code,
            story_length = document.getElementById('content').textContent.length,
            story_time = self.time;
        ST.silentRequest('active.php',
            'story=' + encodeURIComponent(story_id) +
            '&active_chars=' + encodeURIComponent(story_length) +
            '&active_time=' + encodeURIComponent(story_time),
            aCallback);
    };

    window.addEventListener('scroll', onEvent);
    //window.addEventListener('touchstart', onEvent);
    onEvent();

    self.stopMeasuringTime = function () {
        // stop measuring reading-time because user started write reply
        stopped = true;
    };

    return self;
}());

