// Add choice
"use strict";
// globals: DH, window, document, Android, setTimeout

var ST = ST || {};

ST.parent = parseInt(Android.getShared(), 10);

ST.titleCase = function (aSentence) {
    // trim leading eol
    var s = aSentence.trim();
    if (s === '') {
        return '';
    }
    // Title case
    return s.substr(0, 1).toUpperCase() + s.substr(1);
};

ST.normalizeSentence = function (aSentence) {
    // normalize sentence (title case, dot at the end)
    // trim leading eol
    var s = aSentence.trim();
    if (s === '') {
        return '';
    }
    // Title case
    s = s.substr(0, 1).toUpperCase() + s.substr(1);
    // ending with dot (unless ?!)
    if (['?', '!', '.', '"'].indexOf(s.substr(-1)) < 0) {
        s = s + '.';
    }
    return s;
};

ST.onSubmitClick = function () {
    // submit new sentence to the story
    var title = ST.titleCase(document.getElementById('title').value),
        sentence = ST.normalizeSentence(document.getElementById('reply').value);

    // check
    if (title === '') {
        ST.error('Choice label is required, make it short and apt');
        document.getElementById('title').focus();
        return;
    }
    if (title.length > 100) {
        ST.error('Title is too long, limit is 100 characters');
        document.getElementById('title').focus();
        return;
    }
    if (sentence === '') {
        ST.error('Text is required, write how the adventure should continue');
        document.getElementById('reply').focus();
        return;
    }
    if (sentence.length > 1000) {
        ST.error('Text is too long, limit is 1000 characters');
        document.getElementById('reply').focus();
        return;
    }

    // disable submit button
    document.getElementById('submit').textContent = 'Wait…';
    document.getElementById('submit').disable = true;
    document.getElementById('reply').focus();
    setTimeout(function () {
        document.getElementById('submit').textContent = 'Submit';
    }, 2500);

    // check max length (on android gboard will sometimes allow longer that maxlength, also dot may be added in normalizer)
    if (sentence.length > 1000) {
        document.getElementById('submit').textContent = 'Submit';
        document.getElementById('limit').style.color = 'red';
        setTimeout(function () {
            document.getElementById('limit').style.color = '';
        }, 500);
        return;
    }

    // add and go back
    ST.request('adventure/write.php', 'parent=' + encodeURIComponent(ST.parent) + '&title=' + encodeURIComponent(title) + '&sentence=' + encodeURIComponent(sentence), function (aData) {
        // -10 means duplicate choice
        if (aData.code === -10) {
            document.getElementById('title').focus();
            return;
        }
        if (aData.code < 0) {
            console.error(aData);
            return;
        }
        //Android.setShared(aData.detail);
        Android.setShared(ST.parent);
        Android.loadUrl('file:///android_asset/adventure/adventure.html');
    });
};

ST.onBack = function () {
    // Go back
    Android.setShared(ST.parent);
    Android.loadUrl('file:///android_asset/adventure/adventure.html');
};

ST.onReplyInput = function (event) {
    // Show remaining characters
    document.getElementById('limit').textContent = (event.target.value.length + 1) + '/1000';
};

window.addEventListener('DOMContentLoaded', function () {
    // initialize window
    console.log('ST.branch', ST.branch);
    DH.console.showOnMultipleClicks(true);

    document.getElementById('submit').addEventListener('click', ST.onSubmitClick);
    document.getElementById('cancel').addEventListener('click', ST.onBack);
    document.getElementById('reply').addEventListener('input', ST.onReplyInput);

    // set back to return to current story
    var java = 'java';
    Android.setBack(java + 'script:ST.onBack()');
});
