// Render adventure
"use strict";
// globals: DH, window, document, Android, setTimeout, Billing

var ST = ST || {};

ST.branch = parseInt(Android.getShared() || '1', 10);

ST.onBack = function () {
    // Go back
    Android.loadUrl('file:///android_asset/android.html');
};

ST.onChoice = function (event) {
    // Show branch when user choose
    Android.setShared(event.target.data);
    Android.loadUrl('file:///android_asset/adventure/adventure.html');
};

ST.onAddChoice = function () {
    // Add new choice
    if (!window.hasOwnProperty('Billing') || !Billing.isAvailable()) {
        DH.splash('Error', 'OK', 'pink', 'Billing service is not available, wait please...');
        return;
    }
    if (!Billing.purchaseExists('story_limit')) {
        var sp = DH.splash('Wait', ['Buy', 'Cancel'], 'skyblue', 'To became writer you need to make a one-time purchase of $1', function (aButton) {
            if (aButton === 'Buy') {
                Billing.purchase('story_limit', function (aOk, aSku) {
                    console.log('purchased', aOk, aSku);
                    if (aOk) {
                        ST.onSubmitClick();
                    }
                });
            }
        }, '80vw');
        sp.bgClickDisable();
        return;
    }
    Android.setShared(ST.data.id);
    Android.loadUrl('file:///android_asset/adventure/add-choice.html');
};

ST.render = function (aTitle, aParent, aSentence, aChoices) {
    // Render branch
    // title
    document.getElementById('back').onclick = function () {
        if (aParent) {
            Android.setShared(aParent);
            Android.loadUrl('file:///android_asset/adventure/adventure.html');
        } else {
            ST.onBack();
        }
    };
    document.getElementById('title').textContent = aTitle;
    // sentence
    document.getElementById('sentence').textContent = aSentence;
    // choice
    var i, ul = document.getElementById('choices'), li;
    for (i = 0; i < aChoices.length; i++) {
        li = document.createElement('li');
        li.data = aChoices[i].id;
        li.textContent = aChoices[i].title;
        li.onclick = ST.onChoice;
        ul.appendChild(li);
    }
    // add
    li = document.createElement('li');
    li.data = -1;
    li.className = 'add';
    li.textContent = aChoices.length === 0 ? 'Add first choice' : 'Add different choice';
    li.onclick = ST.onAddChoice;
    ul.appendChild(li);
    if (aChoices.length === 0) {
        document.getElementById('your_choice').textContent = 'Story ends here but you can continue by adding reader a choice how it should continue...';
    } else {
        document.getElementById('your_choice').textContent = 'Your choice:';
    }
};

window.addEventListener('DOMContentLoaded', function () {
    // initialize window
    console.log('ST.branch', ST.branch);
    DH.console.showOnMultipleClicks(true);

    ST.request('adventure/read.php', 'branch=' + encodeURIComponent(ST.branch), function (aData) {
        // for now allow 1 redirect, e.g. #22 in sentence
        var r = aData.detail.sentence.match(/^#([0-9]+)/);
        if (r) {
            ST.branch = parseInt(r[1], 10);
            console.warn('Redirect!', ST.branch);
            ST.request('adventure/read.php', 'branch=' + encodeURIComponent(ST.branch), function (aData) {
                ST.data = aData.detail;
                ST.render(aData.detail.title, aData.detail.parent, aData.detail.sentence, aData.detail.choice);
            });
            return;
        }
        // render branch
        ST.data = aData.detail;
        ST.render(aData.detail.title, aData.detail.parent, aData.detail.sentence, aData.detail.choice);
    });

    // show branch id
    document.getElementById('id').textContent = ST.branch;

    // set back to return to current story
    var s = 'java';
    Android.setBack(s + 'script:ST.onBack()');
});
