// Android billing (in app purchases)
"use strict";
// require: android, flash, splash
// globals: document, window, Android

var DH = DH || {};

DH.billing = {};

DH.billing.refresh = function () {
    // Refresh list of purchased items from google play store
    var sp;
    sp = DH.splash('Wait please...', ['Cancel'], '#8b6', function (aContent) {
        aContent.textContent = 'Requesting list of purchased items from Google play store, this may take a while...';
        // do some request
        Android.billingPurchasesCallback = function () {
            sp.hide();
        };
        Android.billingPurchasesAsync();
    }, function () {
        DH.billing.showAgain(); //(DH.billing.recentProducts);
    }, '80vw', 'auto');
    window.sp = sp;
};

DH.billing.purchase = function (aProduct) {
    // Buy single product
    Android.billingPurchaseCallback = function () {
        alert('purchase made ' + Android.billingItemDetails());
    };
    Android.billingPurchase(aProduct);
};

DH.billing.showAgain = function () {
    // Show same products again
    DH.billing.show(DH.billing.recentProducts);
};

DH.billing.show = function (aProducts) {
    // Show products that can be purchased
    DH.billing.recentProducts = aProducts;

    function onPurchase(event) {
        Android.billingPurchase(event.target.dataSku);
    }

    var sp = DH.flash('Products', ['Close', 'Refresh'], '#9c7', function (aContent) {
        var sku, div, img, container, text, buy, owned, purchases = Android.billingPurchasesList().split('\n');
        for (sku in aProducts) {
            if (aProducts.hasOwnProperty(sku)) {
                div = document.createElement('div');
                div.className = 'item';
                //div.style.display = 'flex';

                // image
                img = document.createElement('img');
                img.src = 'billing/' + sku + '.png';
                img.style.marginRight = '1ex';
                div.appendChild(img);

                container = document.createElement('div');
                container.style.width = '100%';
                div.appendChild(container);

                owned = purchases.indexOf(sku) >= 0; // === 'ghost_unlock_ads';

                buy = document.createElement('button');
                buy.className = 'buy';
                buy.style.float = 'right';
                if (owned) {
                    buy.classList.add('owned');
                    buy.textContent = 'Owned';
                } else {
                    buy.textContent = 'Buy for ' + aProducts[sku].price;
                    buy.dataSku = sku;
                    buy.onclick = onPurchase;
                }
                container.appendChild(buy);

                text = document.createElement('div');
                text.textContent = aProducts[sku].text;
                container.appendChild(text);

                aContent.appendChild(div);
            }
        }
    }, function (aButton) {
        if (aButton === 'Refresh') {
            sp.hide();
            DH.billing.refresh();
        }
    });
    window.sp = sp;
};
