// Display my patreon link
// require: storage, storage3, sha1
"use strict";
// globals: document, window, setTimeout, Android

var DH = DH || {};

DH.patreon = function (aDelaySeconds, aTexts, aCallback, aFrequency, aForceShow) {
    // Display my patreon link
    var storage, div, lip, text, close, input, texts = aTexts || [
        'You can support me on patreon',
        "My patreon supporters don't see this message!",
        "Block this annoying message by becoming my patron",
        "My patrons can make (reasonable) feature requests",
        "Every time you don't support me on patreon I eat instant noodles for a month!",
        "Nobody likes beggers, silence me by becoming my patron",
        "My patrons can have all my apps for free!",
        "Would you rather see unskipable ads here? Support me on patreon and there will never be ads here",
        // my patrons
        "This project is supported on patreon by few good people"
    ];

    // only show it every nth time
    if (aFrequency > 0) {
        DH.patreonFrequency = DH.patreonFrequency || 0;
        DH.patreonFrequency++;
        if (DH.patreonFrequency % aFrequency !== 0) {
            return;
        }
    }

    // find storage
    storage = DH.storage || DH.storage3;

    function hide() {
        // hide lip
        lip.style.opacity = 0;
        lip.style.bottom = '-2cm';
        setTimeout(function () {
            if (div.parentElement) {
                div.parentElement.removeChild(div);
            }
        }, 300);
    }

    function onCheckPassword() {
        // check password and save it if ok
        var h = input.value, i;
        for (i = 0; i < 100; i++) {
            h = DH.sha1(h + 'DontBeABadGuyOk');
        }
        if (h === '1b158fd853d8db541253f77028d30587fa3d4f87' || h === '56afab527d40c949d4392a6bb7d7d146fc21197f') {
            lip.style.backgroundColor = 'lightgreen';
            text.textContent = 'Thank you!';
            storage.writeBoolean('DH.patron', true, function () {
                setTimeout(hide, 2000);
            });
        }
    }

    function unlock() {
        // Show input with password
        input = document.createElement('input');
        input.oninput = onCheckPassword;
        text.textContent = 'Password: ';
        text.appendChild(input);
        setTimeout(function () {
            text.focus();
        }, 300);
    }

    function show(aMessage) {
        // show message
        var old = 0, u, i;

        // hide previous?
        try {
            if (DH.patreonPreviousHide) {
                DH.patreonPreviousHide();
            }
            DH.patreonPreviousHide = hide;
        } catch (e) {
            console.warn(e);
        }

        // div
        div = document.createElement('div');
        div.style.position = "fixed";
        div.style.bottom = 0;
        div.style.left = 0;
        div.style.right = 0;
        div.style.width = '100%';
        div.style.display = 'flex';
        div.style.justifyContent = 'center';
        div.style.alignItems = 'center';
        div.style.fontSize = 'small';
        div.style.color = 'black';
        div.style.zIndex = 9999;

        // lip
        lip = document.createElement('div');
        lip.style.borderTopLeftRadius = '1ex';
        lip.style.borderTopRightRadius = '1ex';
        lip.style.padding = '1ex';
        lip.style.boxShadow = '0 0 2ex black';
        lip.style.backgroundColor = 'skyblue';
        lip.style.opacity = 0;
        lip.style.transition = 'opacity 0.2s linear, bottom 0.2s cubic-bezier(1.000, -0.530, 0.405, 1.425)';
        lip.style.bottom = '-2cm';
        lip.style.position = 'absolute';
        lip.style.display = 'flex';
        lip.style.alignItems = 'center';
        div.appendChild(lip);

        // text
        text = document.createElement('span');
        //text.innerHTML = aMessage.replace(/\bpatreon\b/g, '<a target="_blank" href="https://www.patreon.com/DusanHalicky">patreon</a>').replace(/\bpatrons\b/g, '<a target="_blank" href="https://www.patreon.com/DusanHalicky">patrons</a>').replace(/\bpatron\b/g, '<a target="_blank" href="https://www.patreon.com/DusanHalicky">patron</a>');
        text.innerHTML = aMessage.replace(/\bpatreon\b/g, '<span class="patreon">patreon</span>').replace(/\bpatrons\b/g, '<span class="patreon">patrons</span>').replace(/\bpatron\b/g, '<span class="patreon">patron</span>');
        function openPatreon() {
            if (window.hasOwnProperty('Android') && Android.patreon) {
                Android.patreon();
                return;
            }
            window.open('https://www.patreon.com/DusanHalicky');
        }
        u = text.getElementsByClassName('patreon');
        console.log('zz', u);
        for (i = 0; i < u.length; i++) {
            u[i].style.color = 'blue';
            u[i].style.textDecoration = 'underline';
            u[i].onclick = openPatreon;
        }
        text.ondblclick = unlock;
        text.ontouchend = function () {
            var now = Date.now();
            if (now - old < 500) {
                unlock();
            }
            old = now;
        };
        lip.appendChild(text);

        // close button
        close = document.createElement('span');
        close.textContent = '✕';
        close.style.color = 'blue';
        close.style.padding = '0.5ex';
        close.style.margin = 0;
        close.style.cursor = 'pointer';
        close.onclick = hide;
        lip.appendChild(close);

        // show it and animate
        document.body.appendChild(div);
        setTimeout(function () {
            lip.style.opacity = 1;
            lip.style.bottom = 0;
        }, 300);
    }

    // show random text now
    if (aForceShow) {
        show(texts[Math.floor(texts.length * Math.random())]);
        return;
    }

    // is patron? (some features are only available for patrons)?
    storage.readBoolean('DH.patron', false, function (aValue) {
        DH.patron = aValue;
        if (aCallback) {
            aCallback(aValue);
        }
        // non-patrons will see message (after specified time)
        if (!aValue) {
            setTimeout(function () {
                if (!DH.patron) {
                    storage.inc('DH.patreon.next', -1, function (aNext) {
                        show(texts[aNext % texts.length]);
                    });
                }
            }, Math.max(1000, (aDelaySeconds || 30) * 1000));
        }
    });
};

DH.patreonDaily = function (aDelaySeconds, aTexts, aCallback, aFrequency) {
    // Display patreon once a day
    var today = (new Date()).toISOString().substr(0, 10), storage = DH.storage || DH.storage3;
    storage.readString('DH.patreon.daily', '', function (aValue) {
        if (aValue !== today) {
            if (aValue !== '') {
                DH.patreon(aDelaySeconds, aTexts, aCallback, aFrequency);
            }
            storage.writeString('DH.patreon.daily', today);
        }
    });
};
