// Moderate stories and sentences
"use strict";
// globals: window, document, DH, Android

var ST = ST || {};

ST.onComboChange = function (event) {
    // send moderation request when user changes combo
    if (event.target.value.toString() === '4') {
        if (!confirm('Are you sure you want to BAN this author and IP?')) {
            return;
        }
    }
    ST.comboColor(event.target);
    console.log('change', 'story', event.target.dataStory, 'sentence', event.target.dataSentence, 'status', event.target.value);
    ST.request(
        'moderate.php',
        'story=' + encodeURIComponent(event.target.dataStory) +
            '&sentence=' + encodeURIComponent(event.target.dataSentence) +
            '&status=' + encodeURIComponent(event.target.value),
        function (aData) {
                console.info(aData);
            }
    );
};

ST.onDblClickDetail = function (event) {
    // show story detail
    var s, obj = event.target.dataDetail;
    console.log('ST.onDblClickDetail', obj);
    s = prompt('Change sentence', obj.message);
    if (s && (s !== obj.message)) {
        ST.request(
            'mod-sentence-rename.php',
            'sentence=' + encodeURIComponent(obj.id) +
                '&message=' + encodeURIComponent(s),
            function (aData) {
                    console.info(aData);
                    event.target.textContent = s;
                }
        );
    }
    //DH.console.showRaw(event.target.dataDetail);
};

ST.onChangeSentence = function (event) {
    console.log(event.target.textContent, event.target.dataDetail);
    // When user leave sentence update it on server
    var id = event.target.dataDetail.id,
        orig = event.target.dataDetail.message.trim(),
        message = event.target.textContent.trim();
    if (message.length > 250) {
        alert('Maximal length of 250 exceeded! Shorten the sentence!');
        return;
    }
    //console.log('ST.onBlurMessage', id, orig !== message, message);
    if (orig !== message) {
        event.target.style.opacity = 0.5;
        ST.request('mod-sentence-rename.php', 'sentence=' + encodeURIComponent(id) + '&message=' + encodeURIComponent(message), function (aData) {
            console.log(aData, id, message);
            event.target.style.opacity = 1;
            event.target.dataMessage = message;
        });
    }
};

window.addEventListener('DOMContentLoaded', function () {
    // initialize window
    DH.console.showOnMultipleClicks(true);

    // fetch unmoderated stuff
    ST.request('unmoderated.php', '', function (aData) {
        var d = aData,
            sentences = document.getElementById('sentences'),
            i,
            s,
            one,
            span,
            hr;
        window.d = d;

        // unmoderated story name
        document.getElementById('story').textContent = d.detail.story.name || 'Moderate';

        // unmoderated sentences
        sentences.textContent = '';
        if (d.detail.story.sentences.length <= 0) {
            sentences.textContent = 'Nothing new to moderate!';
        }
        for (i = 0; i < d.detail.story.sentences.length; i++) {
            s = d.detail.story.sentences[i];
            one = document.createElement('div');
            sentences.appendChild(one);
            // combo
            one.appendChild(ST.combo(s.status, s.story, s.id, ST.onComboChange));
            // text
            span = document.createElement('span');
            span.textContent = s.message;
            span.dataDetail = d.detail.story.sentences[i];
            span.contentEditable = true;
            span.addEventListener('blur', ST.onChangeSentence);
            //span.addEventListener('dblclick', ST.onDblClickDetail);
            one.appendChild(span);
            // hr
            if ((i === 2) && (parseInt(s.status, 10) === 3)) {
                hr = document.createElement('div');
                hr.className = 'hr';
                sentences.appendChild(hr);
            }
        }

        document.getElementById('v2').href = 'mod-sentence.html#' + parseInt(d.detail.story.id, 10);
    });

    document.getElementById('next').onclick = function () { Android.loadUrl('file:///android_asset/moderate.html'); };
});
