// Likes and dislikes
"use strict";
// globals: document, window

var ST = ST || {};

ST.vote = (function () {
    var self = {};

    function cast(aStoryId, aLikes, aDislikes) {
        // cast a vote and update elements
        document.getElementById('likes').style.opacity = 0.5;
        ST.request('story-vote.php',
            'story=' + encodeURIComponent(aStoryId) +
            '&likes=' + encodeURIComponent(aLikes ? 1 : 0) +
            '&dislikes=' + encodeURIComponent(aDislikes ? 1 : 0), function (aData) {
                console.log('voted', aData);
                self.render(aStoryId, aData.detail.likes, aData.detail.dislikes);
            });
    }

    self.like = function (aStoryId, aStoryName, aStoryLength) {
        // like story
        cast(aStoryId, 1, 0);
         // like will add it to favorites
        ST.favorite.add(aStoryId, aStoryName, aStoryLength);
    };

    self.dislike = function (aStoryId) {
        // dislike story
        cast(aStoryId, 0, 1);
        // dislike will remove it from favorites?
        ST.favorite.remove(aStoryId);
    };

    self.render = function (aStoryId, aLikes, aDislikes, aStoryName, aStoryLength) {
        // render counts and assign events
        document.getElementById('likes_count').onclick = function () {
            self.like(aStoryId, aStoryName, aStoryLength);
        };
        document.getElementById('dislikes_count').onclick = function () {
            self.dislike(aStoryId);
        };
        document.getElementById('likes_count').textContent = (aLikes || '0') + '👍';
        document.getElementById('dislikes_count').textContent = '👎' + (aDislikes || '0');
        document.getElementById('likes').style.opacity = 1;
    };

    return self;
}());

